#include <QtGui>
#include "addressbookmodel.h"
#include "completiondelegate.h"

int main( int argc, char* argv[] )
{
  QApplication app( argc, argv );

  // Datei im lokalen Ordner ffnen
  QFile file("addressbook.csv");
  if ( !file.open(QIODevice::ReadOnly|QIODevice::Text) )
	  return 1;

  // Inhalt in String einlesen
  QString addresses = QString::fromUtf8(file.readAll());
  AddressbookModel model(addresses);

  QListView listView;
  listView.setModel(&model);
  listView.setModelColumn(0);
  listView.setItemDelegate(new CompletionDelegate(&listView));
  listView.show();

  QTreeView treeView;
  treeView.setModel(&model);
  treeView.setItemDelegate(new CompletionDelegate(&treeView));
  treeView.show();

  QTableView tableView;
  tableView.setModel(&model);
  tableView.setItemDelegate(new CompletionDelegate(&tableView));
  tableView.show();

  return app.exec();
}
