#include <QtGui>
#include <QtSql>
#include <QDebug>

int main(int argc, char* argv[])
{
  QApplication app(argc, argv);

  QSqlDatabase db = QSqlDatabase::addDatabase("QMYSQL");
  db.setHostName("datenbankserver.example.com");
  db.setDatabaseName("firma");
  db.setUserName("user");
  db.setPassword("pass");

  if (!db.open()) {
     qDebug() << db.lastError();
     return 1;
  }

  QSqlQuery query("SELECT vorname, nachname FROM mitarbeiter");
  QSqlRecord record = query.record();
  while (query.next()) {
    QString  vorname = 
       query.value(record.indexOf("vorname")).toString();
    QString  nachname = 
       query.value(record.indexOf("nachname")).toString();
    qDebug() << query.at() << ":" << nachname << "," << vorname;
  }
  query.exec("DELETE FROM mitarbeiter WHERE nachname = 'Hasse'");
  qDebug() << query.numRowsAffected(); // "1"
  query.prepare("INSERT INTO mitarbeiter (nachname, vorname, abteilung)"
                "VALUES(:nachname, :vorname, :abteilung)");
  query.bindValue(":nachname", "Hasse");
  query.bindValue(":vorname", "Peter");
  query.bindValue(":abteilung", 3);
  query.exec();
  query.prepare("INSERT INTO mitarbeiter (nachname, vorname, abteilung)"
                "VALUES(?, ?, ?");
  query.bindValue(0, "Schwan");
  query.bindValue(1, "Waldemar");
  query.bindValue(2, 3);
  query.exec();
  query.prepare("CALL zaehlePersonal(?)");
  query.bindValue(0, 0, QSql::Out);
  query.exec();
  qDebug() << query.boundValue(0).toInt();
  query.exec("CALL zaehlePersonal (@outwert)");
  query.exec("SELECT @outwert");
  query.next();
  qDebug() << query.value(0);
  return 0;
}
