
#include <QtGui>
#include <QtSql>
#include <QDebug>

int main(int argc, char* argv[])
{
  QApplication app(argc, argv);

  QSqlDatabase db = QSqlDatabase::addDatabase("QMYSQL");
  db.setHostName("datenbankserver.example.com");
  db.setDatabaseName("firma");
  db.setUserName("user");
  db.setPassword("pass");
  db.setHostName("localhost");
  db.setDatabaseName("firma");
  db.setUserName("root");
  db.setPassword("");

  if(!db.open())
    return 1;

  QTableView tableView;
  QSqlTableModel tableModel;
  tableModel.setTable("mitarbeiter");
  tableModel.select();
  tableModel.removeColumn(0);
  tableView.setModel(&tableModel);
  tableView.setWindowTitle("Tabelle 'mitarbeiter'");
  tableView.show();
  QTableView tableRelationalView;
  QSqlRelationalTableModel tableRelationalModel;
  tableRelationalModel.setTable("mitarbeiter");
  QSqlRelation rel("abteilungen", "id", "name");
  tableRelationalModel.setRelation(3, rel);
  tableRelationalModel.select();
  tableRelationalView.setModel(&tableRelationalModel);
  tableRelationalView.setItemDelegate(
 		new QSqlRelationalDelegate(&tableRelationalView));
  tableRelationalView.setWindowTitle(
		"Tabelle mit aufgelsten Relationen");
  tableRelationalView.show();
  QTableView queryView;
  QSqlQueryModel queryModel;
  queryModel.setQuery("SELECT abteilungen.name, "
	"COALESCE(COUNT(mitarbeiter.nachname),0) "
	"FROM abteilungen LEFT JOIN mitarbeiter "
	"ON mitarbeiter.abteilung = abteilungen.id "
	"GROUP BY mitarbeiter.abteilung");

  if (queryModel.lastError().isValid())
    qDebug() << queryModel.lastError();

  queryModel.setHeaderData(0, Qt::Horizontal, 
				QObject::tr("Abteilung"));
  queryModel.setHeaderData(1, Qt::Horizontal, 
				QObject::tr("Anzahl Mitarbeiter"));
  queryView.setModel(&queryModel);
  queryView.setWindowTitle("Mitarbeiteranzahl nach Abteilungen");
  queryView.show();

  QWidget w;
  QPushButton *submitPb = new QPushButton(
		QObject::tr("nderungen speichern"));
  QPushButton *revertPb = new QPushButton(
		QObject::tr("nderungen zurckrollen"));
  QGridLayout *lay = new QGridLayout(&w);
  QTableView *manualTableView = new QTableView;
  lay->addWidget(manualTableView, 0, 0, 1, 2);
  lay->addWidget(submitPb, 1, 0);
  lay->addWidget(revertPb, 1, 1);
  QSqlTableModel manualTableModel;
  manualTableModel.setTable("mitarbeiter");
  manualTableModel.select();
  manualTableModel.setEditStrategy(
		QSqlTableModel::OnManualSubmit);
  manualTableView->setModel(&manualTableModel);
  QObject::connect(submitPb, SIGNAL(clicked(bool)), 
		&manualTableModel, SLOT(submitAll()) );
  QObject::connect(revertPb, SIGNAL(clicked(bool)), 
		&manualTableModel, SLOT(revertAll()) );
  w.setWindowTitle("Manuell rcksetzbare Tabelle");
  w.show();

  return app.exec();
}

