#ifndef DATENSATZ_H
#define DATENSATZ_H

#include <QString>
#include <QDataStream>
#include <QDebug>

class Datensatz
{
    
  private:
    QString m_vorname;
    QString m_nachname;
    QString m_strasse;
    int m_hausnummer;
    int m_plz;
    QString m_ort;

  public:
    Datensatz(QString vorname, QString nachname, QString strasse, 
      int hausnummer, int plz, QString ort)
    {
      m_vorname = vorname;
      m_nachname = nachname;
      m_strasse = strasse;
      m_hausnummer = hausnummer;
      m_plz = plz;
      m_ort = ort;
    }

    Datensatz() {}

    QString vorname() const { return m_vorname; }
    QString nachname() const { return m_nachname; }
    QString strasse() const { return m_strasse; }
    int hausnummer() const { return m_hausnummer; }
    int plz() const { return m_plz; }
    QString ort() const { return m_ort; }
   
    void setVorname(const QString& vorname) { m_vorname = vorname; }
    void setNachname(const QString& nachname) { m_nachname = nachname; }
    void setStrasse(const QString& strasse) { m_strasse = strasse; }
    void setHausnummer(int hausnummer) { m_hausnummer = hausnummer; }
    void setPlz(int plz) { m_plz = plz; }
    void setOrt(const QString& ort) { m_ort = ort; }

    Datensatz(const Datensatz& ds) {
      m_vorname = ds.m_vorname;
      m_nachname = ds.m_nachname;
      m_strasse = ds.m_strasse;
      m_hausnummer = ds.m_hausnummer;
      m_plz = ds.m_plz;
      m_ort = ds.m_ort;
    }

    Datensatz& operator=(const Datensatz& ds) {
      m_vorname = ds.m_vorname;
      m_nachname = ds.m_nachname;
      m_strasse = ds.m_strasse;
      m_hausnummer = ds.m_hausnummer;
      m_plz = ds.m_plz;
      m_ort = ds.m_ort;
      return *this;
    }
};
QDataStream& operator<<(QDataStream &s, const Datensatz &d)
{
  s << d.vorname() << d.nachname() << d.strasse() 
    << (qint32)d.hausnummer() << (qint32)d.plz() << d.ort();
  return s;
}
QDataStream& operator>>(QDataStream &s, Datensatz(&d))
{
  QString data;
  qint32 number;
  s >> data;
  d.setVorname(data); 
  s >> data;
  d.setNachname(data); 
  s >> data;
  d.setStrasse(data); 
  s >> number;
  d.setHausnummer(number); 
  s >> number;
  d.setPlz(number); 
  s >> data;
  d.setOrt(data); 

  return s;
}

#endif // DATENSATZ_H
